<!DOCTYPE html>
<html>
    <head>
      <meta charset="UTF-8">
      <meta name="viewport" content="width=device-width">
      <link rel="icon" href="logo.png">
	    <script language=javascript type=text/javascript src="jquery-3.3.1.min.js"></script>
      <script language=javascript type=text/javascript src="knockout-3.4.2.js"></script>
	    <script language=javascript type=text/javascript src="config.js"></script>
      <script language=javascript type=text/javascript src="dev.js"></script>
	    <script language=javascript type=text/javascript src="utils.js"></script>
      <script language=javascript type=text/javascript src="openEHR.js"></script>
      <script language=javascript type=text/javascript src="viewModel.js"></script>
	    <script language=javascript type=text/javascript src="MM.js"></script>
	    <script language=javascript type=text/javascript src="CIM.js"></script>
      <script language=javascript type=text/javascript src="client_tests.js"></script>
      <title>openCQA - An open tool for Collaborative knowledge-based healthcare data Quality Assessment</title>
      <style>
        .box_center {
          background-color: white;
          top: 50%;
          left: 50%;
          border: 1px solid;
          border-radius: 5px;
          padding: 10px;
          position: fixed;
          transform: translate(-50%, -50%);
        }
        table {
        	border-collapse: collapse;
        }
        tbody tr:hover {
          background-color: lightgrey;
        }
        th {
        	border: 1px solid;
        	background-color:WhiteSmoke;
        	vertical-align:top;
        }
        td {
        	border: 1px solid;
        }
        .close {
          float:right;
          display:inline-block;
          padding:0px 0px;
          cursor:pointer;
        }
      </style>
    </head>
    <body style="font-family: Arial;">

    <!--  logo  -->
    <style>
      #logo {
        	position: fixed;
        	bottom: 5px;
          right: 5px;
          font-size:16px;
          font-weight:bold;
          background-color: white;
          border: 0px;
          border-radius: 5px;
        }
    </style>
    <div id="logo" title="An open tool for Collaborative knowledge-based healthcare data Quality Assessment">
      <a href="https://gitlab.plri.de/tute/openehr-dq" target="blank" style="text-decoration:none;"><span style="color:Chocolate; font-style:italic; font-weight:lighter;">open</span><span style="color:darkblue">CQA</span></a>
    </div>

    <!-- Navigation Bar -->
    <style>
      ul.navbar {
        list-style-type: none;
        margin: 0px;
        padding: 0px;
        top: 0px;
        position:fixed;
        width:100%;
        height:48px;
        overflow: hidden;
        background-color: LightSkyBlue;
      }

      ul.navbar li {
        float: left;
        margin: 0px;
      }

      .show_hide_trigger{
        font-weight:bold;
        cursor: pointer;
      }

      ul.navbar li span {
        display: block;
        text-align: center;
        padding: 14px 16px;
        text-decoration: none;
      }

      ul.navbar li span:hover:not(.active) {
        background-color:DeepSkyBlue;
      }

      .content_right {
        margin-top: 48px;
        transition: 0.5s;
      }

      div.left_list {
        top: 0px;
        margin-top: 48px;
        padding: 0px;
        position:fixed;
        overflow: auto;
        background-color: lightgrey;
        height:100%;
        transition: 0.5s;
      }

      div.left_list table {
        border: 0px solid;
      }

      div.left_list table td {
        cursor: pointer;
        border: 0px solid;
        height:48px;
        padding-right:5px;
        padding-left:5px;
      }

      div.left_list tbody tr:hover {
        text-decoration:underline;
      }

      .selected {
        text-decoration:line-through;
      }

      div.left_list table th {
        background-color: white;
        border: 0px solid;
        height:20px;
      }

    </style>
    <ul class="navbar">
      <li title="List elements of knowledge base, i.e. sets of measurement methods and clinical informations models (CIM)." onclick="toggle_nav()">
        <span id="kb_trigger" class="show_hide_trigger">&#9776;</span>
  		</li>
      <li id="DimensionsDiv" title="Dimensions of interest for characterization values, e.g. mean compliance to plausibility rule can be returned for whole dataset, per site, per participation, per patient, per time interval (year, quarter, month, week, day, before/after intervention), ETL- cycle or something else. Dimensions specified here, will be applied to all MMs added afterwards.">
        <span id="dimensions_trigger" class="show_hide_trigger">Dimensions</span>
  		</li>
      <li title="Specify an AQL-query to retrieve a dataset for DQ-assessment from your local openEHR-platform.">
        <span id="AQL_trigger" class="show_hide_trigger">AQL
          <style>
            .aql_loader {
              border: 4px solid darkblue;
              border-radius: 7px;
              border-top: 4px solid chocolate;
              width: 7px;
              height: 7px;
              -webkit-animation: spin 2s linear infinite; /* Safari */
              animation: spin 2s linear infinite;
              display:inline-block;
            }
          </style>
          <div data-bind="visible: retrieving_data_completed()==false" class="aql_loader"></div>
        </span>
  		</li>
      <li title="View and edit paths properties." data-bind="attr: {title:paths_info}">
        <span id="paths_trigger" class="show_hide_trigger">Paths</span>
  		</li>
      <li title="Export utilities.">
        <span id="export_trigger" class="show_hide_trigger">Export</span>
  		</li>
      <li title="Returns an example row of the dataset on server side and logs it.">
        <span class="show_hide_trigger" onclick="vm.get_result_row()">Example row</span>
  		</li>
      <style>
        .got_connected {
          color: darkblue;
          font-style: italic;
        }
      </style>
      <li style="float:right;" title="Set user and password for openEHR repository.">
  			<span id="credentials_trigger" class="show_hide_trigger" data-bind="text: $root.got_connected, css: {got_connected: $root.got_connected()!=const_user_label}">User</span>
  		</li>
    </ul>

    <!--	Knowledge base including CIMs -->
    <div class="left_list" id="kb_elements" style="display:block;">
      <table>
        <tbody data-bind="foreach: kbMMs">
          <tr style="cursor: pointer;" data-bind="click: $root.clicked_kb" title="Click to add MMs from this knowledge-base.">
            <td title="Number of MMs" data-bind="text: MMs.length"></td>
            <td data-bind="text: kb_tag, attr: {title:description}"></td>
          </tr>
        </tbody>
        <tbody data-bind="foreach: CIMs">
          <tr data-bind="click: $root.clicked_CIM, event: { contextmenu: $root.deleteCIM }" title="Click to add MMs from this clinical information model.">
            <td title="Number of MMs" data-bind="text: MMs().length"></td>
            <td><span data-bind="text: id"></span><span style="color:grey;"> (CIM)</span></td>
          </tr>
        </tbody>
      </table>
      <br>
      <br>
      <br>
    </div>

		<!--	Dimensions	-->
    <div class="box_center" id="dimensions_elements" style="display:none;">
      <span class="close" onclick='this.parentNode.style.display="none";'>X</span>
      <button onclick="vm.add_dimension_to_dimension_list()">Add dimension</button>
      <style>
        #dimension_domain_paths {
          width: 800px;
          height: 20px;
        }
      </style>
      <table>
        <thead>
          <tr>
            <th>Name</th>
            <th>Rule</th>
            <th>Dimension</th>
            <th></th>
          </tr>
        </thead>
        <tbody data-bind="foreach:dimensions">
          <tr>
            <td><input type="text" data-bind="value: name, event: { contextmenu: $root.deleteDimension }"></input></td>
            <td><input type="text" data-bind="value: rule"></input></td>
            <td><textarea id="dimension_domain_paths" data-bind="value: domainPaths" style="min-width: 800px;"></textarea></td>
            <td><button data-bind="click: vm.add_dimension_to_MMs" title="Adds MMs grouping data in this dimension for all visible MMs." style="width:80px;">Add MMs</button></td>
          </tr>
        </tbody>
      </table>
    </div>
    <!--	AQL	-->
    <style>
      #aql {
        width: 1000px;
        height: 400px;
        padding: 10px;
        vertical-align: top;
      }
    </style>
    <div class="box_center" id="AQL_elements" style="display:none;">
      <span class="close" onclick='this.parentNode.style.display="none";'>X</span>
      <textarea id = "aql" data-bind="value:aql"></textarea><br>
      <span>Max. page size:</span><input type="number" data-bind="value:max_pagesize" title="Specify a maximum page size for AQL-query. This number is used to break down the AQL into queries retrieving smaller sets of maximum pagesize rows, i.e. for paging. This is handy if you want to retrieve bigger amounts of data.">
      <button id = "applyAQL" onclick="vm.get_paths()">Apply AQL</button>
      <button onclick="vm.clear_data()" title="Removes all data for this user from server-side and paths from client side.">Clear data</button>
    </div>
    <!--	Paths	-->
    <style>
    #paths_infos {
      min-width: 1000px;
      min-height: 400px;
      padding: 10px;
      vertical-align: top;
    }
    </style>
    <div class="box_center" id="paths_elements" style="display:none;">
      <span class="close" onclick='this.parentNode.style.display="none";'>X</span>
      <textarea id = "paths_infos"></textarea><br>
      <button onclick="vm.load_paths_infos()" title="Loads JSON-string of currently active paths_infos as value of the textarea to enable manual editing.">Load currently active paths infos</button>
      <button onclick="vm.set_as_paths_infos()" title="Tries to set the current content of the textarea as active paths_infos. These are used for example to derive MMs based on the datatype.">Set as paths infos</button>
    </div>
    <!--	Export utilities	-->
    <div class="box_center" id="export_elements" style="display:none;">
      <span class="close" onclick='this.parentNode.style.display="none";'>X</span>
      <button onclick="vm.export_MMs_as_KB()">Export MMs as KB</button><br>
      <button onclick="vm.export_MMs_as_KB(true)">Export MMs as KB with AQL</button><br>
      <button onclick="vm.export_MMs_results_JSON()">Export MMs' results as JSON</button><br>
    </div>
    <!--	Credentials	-->
    <div id="credentials_elements" class="box_center" style="display:none;">
      <span class="close" onclick='this.parentNode.style.display="none";'>X</span>
      <span title="Repository username">Username:<br><input id="repoUser" type="text"/></span><br>
      <span title="Repository password">Password:<br><input id="repoPwd" type="password"/></span><br>
      <center><button onclick="vm.login(this);">Login</button></center>
    </div>

    <!--	edit MMs	-->
    <style>
      .edit_MM_textarea {
        min-width: 800px;
        padding: 10px;
        vertical-align: top;
      }

      .edit_MM_input {
        width: 99%;
      }
    </style>
    <div class="box_center" style="" data-bind="visible: (edit_MM())">
      <span>Tags:</span><br>
      <input type="text" class="edit_MM_input" data-bind="value:edit_MM().tags"><br>
      <span>DomainPaths:</span><br>
      <textarea id="edit_MM_domainPaths" class="edit_MM_textarea" data-bind="value:utils.clean_domain_paths(JSON.stringify(edit_MM().domainPaths, null, 3),'domainPaths',true)"></textarea><br>
      <span>Check:</span><br>
      <input type="text" class="edit_MM_input" data-bind="value:edit_MM().check"><br>
      <span>Group:</span><br>
      <input type="text" class="edit_MM_input" data-bind="value:edit_MM().group"><br>
      <span>Characterization:</span><br>
      <textarea class="edit_MM_textarea" data-bind="value:edit_MM().characterization"></textarea><br>
			<button id = "save" onclick="vm.save_MM_changes('save')">Save</button>
      <button id = "get_MM_as_JSON" onclick="vm.get_MM_as_JSON()" title="Logs MM as JSON to console and copies JSON to clipboard.">JSON</button>
      <button id = "get_R" onclick="vm.get_MM_R()" title="Logs MM as R-script (including simple dummy input) to console and copies JSON to clipboard. This is intended to ease MM-transfer to R-Studio for debugging.">R</button>
      <button id = "log_MM" onclick="vm.log_MM_to_console()" title="Logs the MM to console.">Log MM</button>
      <button id = "abort" onclick="vm.save_MM_changes('abort')">Abort</button>
      <button onclick="vm.delete_MM()" title="Delete this measurement method.">Delete MM</button>
		</div>

    <!--  state  -->
    <style>
      #state_div {
        display:none;
      	position: fixed;
      	top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        padding: 10px 5px 10px  5px;
        border-radius: 15px;
        border: 1px solid black;
        background-color: white;
      }
      .loader {
        border: 5px solid white;
        border-radius: 15px;
        border-top: 5px solid chocolate;
        width: 15px;
        height: 15px;
        -webkit-animation: spin 2s linear infinite; /* Safari */
        animation: spin 2s linear infinite;
      }
      /* Safari */
      @-webkit-keyframes spin {
        0% { -webkit-transform: rotate(0deg); }
        100% { -webkit-transform: rotate(360deg); }
      }
      @keyframes spin {
        0% { transform: rotate(0deg); }
        100% { transform: rotate(360deg); }
      }
    </style>
    <div id="state_div"><center><span id="state_text"></span><div class="loader"></div></center></div>

		<!--	MMs	-->
		<div class="content_right" style="border:0px;" id="MMs">
      <table style="width:100%;">
				<thead>
					<tr>
						<th>
              <span>Nr.</span><br>
              <input type="text" data-bind="value: nrFilter" title="Insert range here to filter MMs." id=MMNrFilter style="width:35px;"></input>
            </th>
            <th style="width:55px;"></th>
						<th>
              <span>Tags</span><br>
              <span> </span><input type="text" data-bind="value: tagFilter" title="Insert tags here to filter MMs - MMs containing these tags will be visible. Use ! before tag expression to exclude tags." id=MMTagFilter></input><br>
            </th>
						<th>
              <span>Execution</span><br>
              <input type="text" data-bind="value: executionFilter" title="Insert ISO8601-datetime here to filter MMs." id=ExecutionFilter></input>
            </th>
						<th id="results_col_th">
              <span>DomainPaths/Results</span><br>
              <input type="text" data-bind="value: domainPathFilter" title="Insert (part) of domainPath here to filter MMs." id=MMDomainPathFilter style="width:500px;"></input>
            </th>
					</tr>
          <tr>
            <th colspan="5" style="text-align:left;">
              <input type="text" data-bind="value: mmFilter" style="min-width: 800px;" title="Insert a JaveScript expression to evaluate here to filter MMs." id=MMFilter></input>
              <button onclick="vm.filterMMs()" data-bind="attr: {title:visibleMMs}">Filter MMs</button>
              <button onclick="vm.clear_MM_filter()" title="Clear all filters set for MMs.">Clear filter</button>
              <button style="float:right;" onclick="vm.delete_MMs()">Delete MMs</button>
              <button style="float:right;" onclick="vm.executeMMs()" data-bind="attr: {title:MMs().length}">Run all MMs</button>
              <style>
                .mms_running {
                  margin-top: 5px;
                  border: 4px solid darkblue;
                  border-radius: 7px;
                  border-top: 4px solid chocolate;
                  width: 7px;
                  height: 7px;
                  -webkit-animation: spin 2s linear infinite; /* Safari */
                  animation: spin 2s linear infinite;
                  display:inline-block;
                }
              </style>
              <div style="float:right;" data-bind="visible:running_MMs()>0">
                <span data-bind="text: running_MMs()"></span>
                <div class="mms_running"></div><!-- this div is the spinnig indicator -->
              </div>
            </th>
          </tr>
				</thead>
				<tbody data-bind="foreach: MMs">
					<tr data-bind="attr: {title: summary}, visible:visible">
						<td data-bind="text: $index"></td>
            <td>
              <center>
                <button data-bind="click: vm.set_edit_MM" title="Click to edit this MM." style="width: 52px;">edit</button>
                <button data-bind="click: vm.clone_MM" title="Click to clone this MM." style="width: 52px;">clone</button>
              </center>
            </td>
						<td data-bind="text: tags"></td>
						<td style="text-align:center;">
              <span data-bind="text: executionTime().display"></span>
              <button data-bind="click: vm.executeMM" title="Click to execute this MM.">Execute</button>
            </td>
						<td class="results" style="min-width: 800px;" data-bind="attr: {title: r}">
              <span style="white-space: pre-wrap;" data-bind="text: displayedDomainPaths"></span>
              <style>
                td.results table th.resultInfo {
                	font-weight: normal;
                }
              </style>
              <table data-bind="visible: (result().results.length>0)">
        				<thead>
        					<tr>
                    <th class="resultInfo" title="Time result was received. (Click to copy results table to clipboard, e.g. to use results table in spreadsheet.)" data-bind="text: result().localTimeString, click: vm.copy_MM_results_table" style="cursor:copy;"></th>
                    <th class="resultInfo" title="Number of dimension levels." data-bind="text: result().results.length"></th>
                    <th><button data-bind="click: vm.show_hide_MM_results_table" title="Click to show/hide this MM's results.">&#9776;</button></th>
                  </tr>
                  <!-- ko if: (!(/\.\w+/.test(tags))) -->
                  <tr>
        						<th title="The dimension level(s) listed in the column below determine the grouping of the input data, e.g. if MM-results are grouped per sitename, the column below will show the names of the sites. (Click to sort by value of this column)" data-bind="click: vm.sort_MM_results_table" id="dimension_level" style="cursor:pointer;">Dimension level</th>
        						<th title="Value characterising data for this dimension level. (Click to sort by value of this column)" data-bind="click: vm.sort_MM_results_table" id="value" style="cursor:pointer;">Value</th>
        						<th title="Size of data-vector characterised by value for this dimension level. (Click to sort by value of this column)" data-bind="click: vm.sort_MM_results_table" id="size" style="cursor:pointer;">Size</th>
        					</tr>
                  <!-- /ko -->
        				</thead>
                  <!-- ko if: (!(/\.\w+/.test(tags)) && (show_results_table())) -->
          				<tbody data-bind="foreach: result().results">
          					<tr onclick='change_color(this)'>
          						<td data-bind="text: dimension_level"></td>
          						<td data-bind="text: value"></td>
          						<td data-bind="text: size"></td>
          					</tr>
          				</tbody>
                  <!-- /ko -->
                  <!-- ko if: ((/\.svg/.test(tags)) && (show_results_table())) -->
          				<tbody data-bind="foreach: result().results">
          					<tr>
          						<td colspan="3">
                        <a target="blank" data-bind="attr: {href: value}">
                        <img data-bind="attr: {src: value}">
                        </a>
                      </td>
          					</tr>
          				</tbody>
                  <!-- /ko -->
                  <!-- ko if: ((/\.pdf/.test(tags)) && (show_results_table())) -->
          				<tbody data-bind="foreach: result().results">
          					<tr>
          						<td colspan="3">
                        <a target="blank" data-bind="attr: {href: value}, text: value"></a>
                      </td>
          					</tr>
          				</tbody>
                  <!-- /ko -->
        			</table>
						</td>
					</tr>
				</tbody>
			</table>
			<span id="end"></span>
		</div>
    <!-- linebreaks at end of page to ensure logo doesn't block last MM-results-->
    <br>
    <br>
    <br>

    <script language="JavaScript">
      //initiate loading of static data
      var RTemplate = "";
      $.ajax({
        url: "/MM_templates/MM_template.r",
        async: true,
        success: function(data) {
          RTemplate = data;
        }
      });
			//hook up basic stuff
			var client = new client();
			var vm = new viewModel();
			ko.applyBindings(vm);
			//limit update-rate on big observable array (just a performance tweak)
			vm.MMs.extend({ rateLimit: 100 });

      //listening to server send events, i.e. to retrieve MM results when computation is done
      var last_connected = Date.now();
      client.connection_id = false;
      var source = new EventSource('/results');
      var error_handling = function(e) {
        if (e.readyState == EventSource.CLOSED) {
          console.error("Connection was closed.");
        }
        console.error(e);
        //try to reconnect (sometimes an error in an MM can cause the connection to be closed on server side)
        if (Date.now()-last_connected>1000) {
          d = new Date();
          console.log(d.toLocaleString() + "." + d.getMilliseconds() + ": " +"Trying to reconnect...");
          last_connected = Date.now();
          client.connection_id = false;
          source = new EventSource('/results');
          source.addEventListener('message', vm.process_SSE, false);
          source.addEventListener('error', error_handling, false);
        }
      };
      source.addEventListener('message', vm.process_SSE, false);
      source.addEventListener('error', error_handling, false);

      //shows/hides left side list of CIMs and sets of MMs from knowledge base
      var toggle_nav = function() {
        var left_list = document.getElementById("kb_elements");
        var content_right = document.getElementById("MMs");
        const nav_max = "250px";
        const nav_min = "0px";
        if (left_list.style.width == nav_max) {
          left_list.style.width = nav_min;
          content_right.style["margin-left"] = nav_min;
        }
        else {
          left_list.style.width = nav_max;
          content_right.style["margin-left"] = nav_max;
        }
      }
      toggle_nav();//set it once in begin

      //possibility to simply change background-color when clicked on sth. (just to highlight for user)
      var change_color = function(elem) {
        elem.style["background-color"] = (elem.style["background-color"] != "yellow") ? "yellow" : "";
      }

      var show_hide = function(trigger_element, element_to_show_or_hide) {
        trigger_element.addEventListener("click", function(event) {
          if (element_to_show_or_hide.style.display == "block") {
            element_to_show_or_hide.style.display =  "none";
          }
          else {
            element_to_show_or_hide.style.display = "block";
          }
        });
      }
      show_hide(document.getElementById("dimensions_trigger"), document.getElementById('dimensions_elements'));
      show_hide(document.getElementById("credentials_trigger"), document.getElementById('credentials_elements'));
      show_hide(document.getElementById("AQL_trigger"), document.getElementById('AQL_elements'));
      show_hide(document.getElementById("paths_trigger"), document.getElementById('paths_elements'));
      show_hide(document.getElementById("export_trigger"), document.getElementById('export_elements'));

      //trigger filter of MMs also on enter in filter input
      var triggerOnEnter = function(event) {
        if (event.keyCode === 13) {
          event.preventDefault();
          vm.filterMMs(event.target.id, event);
        }
      }
      document.getElementById("MMFilter").addEventListener("keyup", triggerOnEnter);
      document.getElementById("MMNrFilter").addEventListener("keyup", triggerOnEnter);
      document.getElementById("MMTagFilter").addEventListener("keyup", triggerOnEnter);
      document.getElementById("ExecutionFilter").addEventListener("keyup", triggerOnEnter);
      document.getElementById("MMDomainPathFilter").addEventListener("keyup", triggerOnEnter);

			//add drag and drop possibility for templates and knowledge bases
			utils.dnd.addEvents(document.getElementById('kb_elements'));
			utils.dnd.perFile = vm.dropped_kb;
			utils.dnd.afterLastFile = function () {};

      //add drag and drop possibility for measurement method results
			utils.dnd.addEvents(document.getElementById('MMs'));
			utils.dnd.perFile = vm.import_MMs_results_JSON;
			utils.dnd.afterLastFile = function () {};

			//if applicable invoke some convenience stuff for development
      if (dev.is) {
        dev.initClientApp();
      }

      vm.get_knowledge_base();
      if (config.authString) {
        vm.get_templates();
      }
      else {
        $("#credentials_elements")[0].style.display = "block";
      }

			function client() {
				var self = this;

        /*  Function to show clients state - not using Knockout since knockouts-GUI-updates are delayed if much processing happens */
        var state_div = document.getElementById("state_div");
        var state_text = document.getElementById("state_text");
        self.set_state = function(iState = false) {
          if (!iState) {
            state_div.style.display = "none";
          }
          else {
            state_text.textContent = iState;
            state_div.style.display = "block";
          }
        }
        self.show_hint = function(message, duration) {
          self.set_state(message);
          setTimeout(() => {
            self.set_state();
          },duration);
        }
			}

    </script>
    </body>
</html>
